import React, { Component } from 'react'
import {LayerSelectorOption} from './LayerSelectorOption';
import '../BasicMapFGP.css';

export class LayerSelector extends Component {
    constructor(props){
        super(props);
        this.state={
            expanded : false,
            layers : [...this.props.layers]

        }
    }

    update(index, cb, evt){
        let layers = [...this.state.layers]
        // no event will be passed 
        if(layers[index].isMultiSelectable === false){
            layers.forEach((layer, idx) => {
                if (idx !== index && layer.isMultiSelectable === false){
                    layer.active = false
                }else if(idx === index && layer.isMultiSelectable === false){
                    layer.active = true;
                }
            })
        // event will be passed
        }else{
            layers[index].active = evt.target.checked
        }
        
        this.setState(
            {
                layers : layers
            },()=>{
                cb(layers[index], layers)
            }
        )
    }

    render() {
        return (
            <div className="mapLayerSelectorWrap">
                <button className={"layerSelectorCloseButton mapLayerInner btn btn-primary "} style={{"display": this.state.expanded ? "block" : "none", "top":"-4px", "right":"18px", "borderRadius":"0"}} onClick={()=>{this.setState({expanded : false})}}>close</button>
            {
                this.state.layers.map((layer, index) => {
                    return(
                        <div style={{"display": this.state.expanded ? "block" : "none"}} className={"mapLayerInner layerSelectPositioningFix"}>
                        <LayerSelectorOption 
                            onClick={this.props.onClick} 
                            layer={layer} 
                            key={index}
                            onChange={this.update.bind(this, index, this.props.onChange)}
                        />
                        </div>)
                })
            }    
            <button className="fgpReactMapLayer" 
                onClick={()=>{this.setState({expanded : true})}}
                style={{"display": !this.state.expanded ? "block" : "none", "textAlign" : "center", "top":"-4px"}} 
            >
                Layers
            </button>  
            </div>
        )
    }
}

export default LayerSelector
